<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Smart Folder: Référence du fichier inc/search_engine.h</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Smart Folder
   &#160;<span id="projectnumber">0.1</span>
   </div>
   <div id="projectbrief">Un répertoire virtuel de recherche de fichiers</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Généré par Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Recherche');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Recherche');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('search__engine_8h.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#define-members">Macros</a> &#124;
<a href="#func-members">Fonctions</a>  </div>
  <div class="headertitle">
<div class="title">Référence du fichier search_engine.h</div>  </div>
</div><!--header-->
<div class="contents">

<p>C'est le header du fichier <a class="el" href="search__engine_8c.html" title="Contient les fonctions du moteur de recherche. ">search_engine.c</a>.  
<a href="#details">Plus de détails...</a></p>
<div class="textblock"><code>#include &quot;<a class="el" href="parser_8h_source.html">parser.h</a>&quot;</code><br />
<code>#include &quot;<a class="el" href="hash__table_8h_source.html">hash_table.h</a>&quot;</code><br />
<code>#include &quot;<a class="el" href="list_8h_source.html">list.h</a>&quot;</code><br />
<code>#include &quot;<a class="el" href="logger_8h_source.html">logger.h</a>&quot;</code><br />
</div>
<p><a href="search__engine_8h_source.html">Aller au code source de ce fichier.</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="define-members"></a>
Macros</h2></td></tr>
<tr class="memitem:a3aba01b4981cc93927e360669ffbd51e"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="search__engine_8h.html#a3aba01b4981cc93927e360669ffbd51e">_SEARCH_ENGINE_H_</a></td></tr>
<tr class="separator:a3aba01b4981cc93927e360669ffbd51e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9da28e6f2a690b177b882e1f445ffd61"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="search__engine_8h.html#a9da28e6f2a690b177b882e1f445ffd61">CHECK_ERR</a>(expr,  msg)&#160;&#160;&#160;if (expr) {<a class="el" href="logger_8h.html#a411855871c07b4730b8c4aabe49437b1">logger</a>(LOG_DEBUG, stderr, &quot;%s\n&quot;, msg);}</td></tr>
<tr class="separator:a9da28e6f2a690b177b882e1f445ffd61"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a30362161c93e3f1a4ee4c673f535b5a8"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="search__engine_8h.html#a30362161c93e3f1a4ee4c673f535b5a8">LENGTH</a>&#160;&#160;&#160;1000</td></tr>
<tr class="separator:a30362161c93e3f1a4ee4c673f535b5a8"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Fonctions</h2></td></tr>
<tr class="memitem:a6d31da2b660e047e17756cb17cd630e8"><td class="memItemLeft" align="right" valign="top">char *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="search__engine_8h.html#a6d31da2b660e047e17756cb17cd630e8">get_filename</a> (char *path)</td></tr>
<tr class="memdesc:a6d31da2b660e047e17756cb17cd630e8"><td class="mdescLeft">&#160;</td><td class="mdescRight">Retourne le nom du fichier.  <a href="#a6d31da2b660e047e17756cb17cd630e8">Plus de détails...</a><br /></td></tr>
<tr class="separator:a6d31da2b660e047e17756cb17cd630e8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3312a7e6e67331d14d8f822365633314"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="search__engine_8h.html#a3312a7e6e67331d14d8f822365633314">crawler</a> (<a class="el" href="structtable__t.html">table_t</a> *table, char *<a class="el" href="hash__table_8c.html#a5420849a0d0b03ddc3afbba911fd301a">search_path</a>)</td></tr>
<tr class="memdesc:a3312a7e6e67331d14d8f822365633314"><td class="mdescLeft">&#160;</td><td class="mdescRight">Une fonction recursive qui va parcourir tous les fichiers sous <em>search_path</em> puis les insère dans une table de hash <em>table</em>.  <a href="#a3312a7e6e67331d14d8f822365633314">Plus de détails...</a><br /></td></tr>
<tr class="separator:a3312a7e6e67331d14d8f822365633314"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a15fb5d1a43443dc75286e2bc71bc799d"><td class="memItemLeft" align="right" valign="top"><a class="el" href="structtable__t.html">table_t</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="search__engine_8h.html#a15fb5d1a43443dc75286e2bc71bc799d">filter</a> (<a class="el" href="structtable__t.html">table_t</a> *table, <a class="el" href="structexpression__t.html">expression_t</a> *strct)</td></tr>
<tr class="memdesc:a15fb5d1a43443dc75286e2bc71bc799d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Filtrer la table de hachage.  <a href="#a15fb5d1a43443dc75286e2bc71bc799d">Plus de détails...</a><br /></td></tr>
<tr class="separator:a15fb5d1a43443dc75286e2bc71bc799d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a327d92026a0d9efe3e5baddddc268763"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="search__engine_8h.html#a327d92026a0d9efe3e5baddddc268763">linker</a> (<a class="el" href="structtable__t.html">table_t</a> *oldtable, <a class="el" href="structtable__t.html">table_t</a> *newtable, <a class="el" href="structtable__t.html">table_t</a> *resolved_table, char *dir_path)</td></tr>
<tr class="memdesc:a327d92026a0d9efe3e5baddddc268763"><td class="mdescLeft">&#160;</td><td class="mdescRight">Vérification si le nombre <em>num</em> est premier.  <a href="#a327d92026a0d9efe3e5baddddc268763">Plus de détails...</a><br /></td></tr>
<tr class="separator:a327d92026a0d9efe3e5baddddc268763"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9a9963268ebccbcbb40d73c5ad015fa9"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="search__engine_8h.html#a9a9963268ebccbcbb40d73c5ad015fa9">search_engine</a> (char *dir_name, char *<a class="el" href="hash__table_8c.html#a5420849a0d0b03ddc3afbba911fd301a">search_path</a>, <a class="el" href="structexpression__t.html">expression_t</a> *strct)</td></tr>
<tr class="memdesc:a9a9963268ebccbcbb40d73c5ad015fa9"><td class="mdescLeft">&#160;</td><td class="mdescRight">Moteur de recherche.  <a href="#a9a9963268ebccbcbb40d73c5ad015fa9">Plus de détails...</a><br /></td></tr>
<tr class="separator:a9a9963268ebccbcbb40d73c5ad015fa9"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Description détaillée</h2>
<div class="textblock"><p>C'est le header du fichier <a class="el" href="search__engine_8c.html" title="Contient les fonctions du moteur de recherche. ">search_engine.c</a>. </p>
<dl class="section author"><dt>Auteur</dt><dd>Abdennadher Raed &amp; Antoniadis Orphée </dd></dl>
<dl class="section version"><dt>Version</dt><dd>0.1 </dd></dl>
<dl class="section date"><dt>Date</dt><dd>27 janvier 2017 </dd></dl>
</div><h2 class="groupheader">Documentation des macros</h2>
<a id="a3aba01b4981cc93927e360669ffbd51e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a3aba01b4981cc93927e360669ffbd51e">&#9670;&nbsp;</a></span>_SEARCH_ENGINE_H_</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define _SEARCH_ENGINE_H_</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Pour éviter des inclusions multiples </p>

</div>
</div>
<a id="a9da28e6f2a690b177b882e1f445ffd61"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a9da28e6f2a690b177b882e1f445ffd61">&#9670;&nbsp;</a></span>CHECK_ERR</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define CHECK_ERR</td>
          <td>(</td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">expr, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">&#160;</td>
          <td class="paramname">msg&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td>&#160;&#160;&#160;if (expr) {<a class="el" href="logger_8h.html#a411855871c07b4730b8c4aabe49437b1">logger</a>(LOG_DEBUG, stderr, &quot;%s\n&quot;, msg);}</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Si <em>expr</em> renvoie une erreur, afficher le message <em>msg</em> </p>

</div>
</div>
<a id="a30362161c93e3f1a4ee4c673f535b5a8"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a30362161c93e3f1a4ee4c673f535b5a8">&#9670;&nbsp;</a></span>LENGTH</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define LENGTH&#160;&#160;&#160;1000</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Représente la taille initiale de la table de hash </p>

</div>
</div>
<h2 class="groupheader">Documentation des fonctions</h2>
<a id="a3312a7e6e67331d14d8f822365633314"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a3312a7e6e67331d14d8f822365633314">&#9670;&nbsp;</a></span>crawler()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void crawler </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structtable__t.html">table_t</a> *&#160;</td>
          <td class="paramname"><em>table</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">char *&#160;</td>
          <td class="paramname"><em>search_path</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Une fonction recursive qui va parcourir tous les fichiers sous <em>search_path</em> puis les insère dans une table de hash <em>table</em>. </p>
<dl class="params"><dt>Paramètres</dt><dd>
  <table class="params">
    <tr><td class="paramname">table</td><td>La table de hash qui contiendra tous les chemins vers les fichiers </td></tr>
    <tr><td class="paramname">search_path</td><td>Le sommet de l'arborescence à parcourir </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a15fb5d1a43443dc75286e2bc71bc799d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a15fb5d1a43443dc75286e2bc71bc799d">&#9670;&nbsp;</a></span>filter()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="structtable__t.html">table_t</a> * filter </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structtable__t.html">table_t</a> *&#160;</td>
          <td class="paramname"><em>table</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structexpression__t.html">expression_t</a> *&#160;</td>
          <td class="paramname"><em>strct</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Filtrer la table de hachage. </p>
<dl class="params"><dt>Paramètres</dt><dd>
  <table class="params">
    <tr><td class="paramname">table</td><td>Table de hachage qui contient tout les fichiers </td></tr>
    <tr><td class="paramname">strct</td><td>Expression polonaise inverse à analyser </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Renvoie</dt><dd>La table de hachage finale filtrée </dd></dl>

</div>
</div>
<a id="a6d31da2b660e047e17756cb17cd630e8"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6d31da2b660e047e17756cb17cd630e8">&#9670;&nbsp;</a></span>get_filename()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">char * get_filename </td>
          <td>(</td>
          <td class="paramtype">char *&#160;</td>
          <td class="paramname"><em>path</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Retourne le nom du fichier. </p>
<dl class="params"><dt>Paramètres</dt><dd>
  <table class="params">
    <tr><td class="paramname">path</td><td>Le chemin absolu vers le fichier </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Renvoie</dt><dd>Un string, le nom du fichier </dd></dl>

</div>
</div>
<a id="a327d92026a0d9efe3e5baddddc268763"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a327d92026a0d9efe3e5baddddc268763">&#9670;&nbsp;</a></span>linker()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void linker </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structtable__t.html">table_t</a> *&#160;</td>
          <td class="paramname"><em>oldtable</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structtable__t.html">table_t</a> *&#160;</td>
          <td class="paramname"><em>newtable</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structtable__t.html">table_t</a> *&#160;</td>
          <td class="paramname"><em>resolved_table</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">char *&#160;</td>
          <td class="paramname"><em>dir_path</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Vérification si le nombre <em>num</em> est premier. </p>
<dl class="params"><dt>Paramètres</dt><dd>
  <table class="params">
    <tr><td class="paramname">oldtable</td><td>Table de hash contenant les fichiers sous <em>searchpath</em> lors du dernier crawl </td></tr>
    <tr><td class="paramname">newtable</td><td>Table de hash contenant les fichiers sous <em>searchpath</em> lors du nouveau crawl </td></tr>
    <tr><td class="paramname">resolved_table</td><td>Table de hash ne contenant que les nouveaux fichiers à ajouer au searchfolder </td></tr>
    <tr><td class="paramname">dir_path</td><td>Le nom du répertoire du résultat de recherche </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a9a9963268ebccbcbb40d73c5ad015fa9"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a9a9963268ebccbcbb40d73c5ad015fa9">&#9670;&nbsp;</a></span>search_engine()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void search_engine </td>
          <td>(</td>
          <td class="paramtype">char *&#160;</td>
          <td class="paramname"><em>dir_path</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">char *&#160;</td>
          <td class="paramname"><em>search_path</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structexpression__t.html">expression_t</a> *&#160;</td>
          <td class="paramname"><em>strct</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Moteur de recherche. </p>
<p>C'est la fonction qui représente le noyau du programme. Elle effectue les taches suivantes :</p><ol type="1">
<li>Création et lancement du processus de recherche (fork)</li>
<li>Création et lancement du thread de terminaison du programme</li>
<li>Création du fichier qui va contenir le PID du programme</li>
<li>Initialisation du table de hachage qui va contenir les hashs des paths dans le dossier <em>dir_path</em> </li>
<li>Appel au crawler, filter, et puis linker pour finalement obtenir les fichiers recherchés.</li>
</ol>
<dl class="params"><dt>Paramètres</dt><dd>
  <table class="params">
    <tr><td class="paramname">dir_path</td><td>Le nom du répertoire du résultat de recherche </td></tr>
    <tr><td class="paramname">search_path</td><td>Le nom du répertoire où la recherche va être effectuer </td></tr>
    <tr><td class="paramname">strct</td><td>Structure qui contient les informations de critères de recherche </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_bfccd401955b95cf8c75461437045ac0.html">inc</a></li><li class="navelem"><a class="el" href="search__engine_8h.html">search_engine.h</a></li>
    <li class="footer">Généré par
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.13 </li>
  </ul>
</div>
</body>
</html>
